import{s as fe,n as ve,o as we}from"../chunks/scheduler.db6b1edd.js";import{S as be,i as ge,g as i,s as a,r as G,A as $e,h as o,f as s,c as r,j as me,u as K,x as l,k as ce,y as xe,a as n,v as N,d as Q,t as V,w as X}from"../chunks/index.ef84021a.js";import{H as Z}from"../chunks/Heading.87f70b00.js";function Te(ee){let u,P,k,j,h,M,p,te='The <a href="https://github.com/huggingface/dataset-viewer" rel="nofollow">dataset viewer</a> has two main components that work together to return queries about a dataset instantly:',H,d,se="<li>a user-facing web API for exploring and returning information about a dataset</li> <li>a server runs the queries ahead of time and caches them in a database</li>",L,m,ne="While most of the documentation is focused on the web API, the server is crucial because it performs all the time-consuming preprocessing and stores the results so the web API can retrieve and serve them to the user. This saves a user time because instead of generating the response every time it gets requested, the dataset viewer can return the preprocessed results instantly from the cache.",A,c,ae="There are three elements that keep the server running: the job queue, workers, and the cache.",I,f,S,v,re="The job queue is a list of jobs stored in a Mongo database that should be completed by the workers. The jobs are practically identical to the endpoints the user uses; only the server runs the jobs ahead of time, and the user gets the results when they use the endpoint.",W,w,ie="There are three jobs:",E,b,oe='<li><code>/splits</code> corresponds to the <code>/splits</code> endpoint. It refreshes a dataset and then returns that dataset’s splits and configurations. For every split in the dataset, it’ll create a new job.</li> <li><code>/first-rows</code> corresponds to the <code>/first-rows</code> endpoint. It gets the first 100 rows and columns of a dataset split.</li> <li><code>/parquet</code> corresponds to the <code>/parquet</code> endpoint. It downloads the whole dataset, converts it to <a href="https://parquet.apache.org/" rel="nofollow">parquet</a> and publishes the parquet files to the Hub.</li>',z,g,le="You might’ve noticed the <code>/rows</code> and <code>/search</code> endpoints don’t have a job in the queue. The responses from these endpoints are generated on demand.",U,$,J,x,ue="Workers are responsible for executing the jobs in the queue. They complete the actual preprocessing requests, such as getting a list of splits and configurations. The workers can be controlled by configurable environment variables, like the minimum or the maximum number of rows returned by a worker or the maximum number of jobs to start per dataset user or organization.",F,T,he='Take a look at the <a href="https://github.com/huggingface/dataset-viewer/tree/main/services/worker#configuration" rel="nofollow">workers configuration</a> for a complete list of the environment variables if you’re interested in learning more.',O,_,R,C,pe="Once the workers complete a job, the results are stored - or <em>cached</em> - in a Mongo database. When a user makes a request with an endpoint like <code>/first-rows</code>, the dataset viewer retrieves the preprocessed response from the cache, and serves it to the user. This eliminates the time a user would’ve waited if the server hadn’t already completed the job and stored the response.",Y,q,de="As a result, users can get their requested information about a dataset (even large ones) nearly instantaneously!",B,y,D;return h=new Z({props:{title:"Server infrastructure",local:"server-infrastructure",headingTag:"h1"}}),f=new Z({props:{title:"Job queue",local:"job-queue",headingTag:"h2"}}),$=new Z({props:{title:"Workers",local:"workers",headingTag:"h2"}}),_=new Z({props:{title:"Cache",local:"cache",headingTag:"h2"}}),{c(){u=i("meta"),P=a(),k=i("p"),j=a(),G(h.$$.fragment),M=a(),p=i("p"),p.innerHTML=te,H=a(),d=i("ul"),d.innerHTML=se,L=a(),m=i("p"),m.textContent=ne,A=a(),c=i("p"),c.textContent=ae,I=a(),G(f.$$.fragment),S=a(),v=i("p"),v.textContent=re,W=a(),w=i("p"),w.textContent=ie,E=a(),b=i("ul"),b.innerHTML=oe,z=a(),g=i("p"),g.innerHTML=le,U=a(),G($.$$.fragment),J=a(),x=i("p"),x.textContent=ue,F=a(),T=i("p"),T.innerHTML=he,O=a(),G(_.$$.fragment),R=a(),C=i("p"),C.innerHTML=pe,Y=a(),q=i("p"),q.textContent=de,B=a(),y=i("p"),this.h()},l(e){const t=$e("svelte-u9bgzb",document.head);u=o(t,"META",{name:!0,content:!0}),t.forEach(s),P=r(e),k=o(e,"P",{}),me(k).forEach(s),j=r(e),K(h.$$.fragment,e),M=r(e),p=o(e,"P",{"data-svelte-h":!0}),l(p)!=="svelte-17a1vcw"&&(p.innerHTML=te),H=r(e),d=o(e,"UL",{"data-svelte-h":!0}),l(d)!=="svelte-12qbi16"&&(d.innerHTML=se),L=r(e),m=o(e,"P",{"data-svelte-h":!0}),l(m)!=="svelte-1uc899o"&&(m.textContent=ne),A=r(e),c=o(e,"P",{"data-svelte-h":!0}),l(c)!=="svelte-19jmf8q"&&(c.textContent=ae),I=r(e),K(f.$$.fragment,e),S=r(e),v=o(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-1r0ezeb"&&(v.textContent=re),W=r(e),w=o(e,"P",{"data-svelte-h":!0}),l(w)!=="svelte-wyypiy"&&(w.textContent=ie),E=r(e),b=o(e,"UL",{"data-svelte-h":!0}),l(b)!=="svelte-n6lfh"&&(b.innerHTML=oe),z=r(e),g=o(e,"P",{"data-svelte-h":!0}),l(g)!=="svelte-1e44dmt"&&(g.innerHTML=le),U=r(e),K($.$$.fragment,e),J=r(e),x=o(e,"P",{"data-svelte-h":!0}),l(x)!=="svelte-7k57hi"&&(x.textContent=ue),F=r(e),T=o(e,"P",{"data-svelte-h":!0}),l(T)!=="svelte-w9oaen"&&(T.innerHTML=he),O=r(e),K(_.$$.fragment,e),R=r(e),C=o(e,"P",{"data-svelte-h":!0}),l(C)!=="svelte-1qi5t6k"&&(C.innerHTML=pe),Y=r(e),q=o(e,"P",{"data-svelte-h":!0}),l(q)!=="svelte-l44lf6"&&(q.textContent=de),B=r(e),y=o(e,"P",{}),me(y).forEach(s),this.h()},h(){ce(u,"name","hf:doc:metadata"),ce(u,"content",_e)},m(e,t){xe(document.head,u),n(e,P,t),n(e,k,t),n(e,j,t),N(h,e,t),n(e,M,t),n(e,p,t),n(e,H,t),n(e,d,t),n(e,L,t),n(e,m,t),n(e,A,t),n(e,c,t),n(e,I,t),N(f,e,t),n(e,S,t),n(e,v,t),n(e,W,t),n(e,w,t),n(e,E,t),n(e,b,t),n(e,z,t),n(e,g,t),n(e,U,t),N($,e,t),n(e,J,t),n(e,x,t),n(e,F,t),n(e,T,t),n(e,O,t),N(_,e,t),n(e,R,t),n(e,C,t),n(e,Y,t),n(e,q,t),n(e,B,t),n(e,y,t),D=!0},p:ve,i(e){D||(Q(h.$$.fragment,e),Q(f.$$.fragment,e),Q($.$$.fragment,e),Q(_.$$.fragment,e),D=!0)},o(e){V(h.$$.fragment,e),V(f.$$.fragment,e),V($.$$.fragment,e),V(_.$$.fragment,e),D=!1},d(e){e&&(s(P),s(k),s(j),s(M),s(p),s(H),s(d),s(L),s(m),s(A),s(c),s(I),s(S),s(v),s(W),s(w),s(E),s(b),s(z),s(g),s(U),s(J),s(x),s(F),s(T),s(O),s(R),s(C),s(Y),s(q),s(B),s(y)),s(u),X(h,e),X(f,e),X($,e),X(_,e)}}}const _e='{"title":"Server infrastructure","local":"server-infrastructure","sections":[{"title":"Job queue","local":"job-queue","sections":[],"depth":2},{"title":"Workers","local":"workers","sections":[],"depth":2},{"title":"Cache","local":"cache","sections":[],"depth":2}],"depth":1}';function Ce(ee){return we(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pe extends be{constructor(u){super(),ge(this,u,Ce,Te,fe,{})}}export{Pe as component};
